<?php

namespace Pinpoint\ReactNewsletter\Model\Resolver;

use Magento\Framework\GraphQl\Config\Element\Field;
use Magento\Framework\GraphQl\Query\ResolverInterface;
use Magento\Framework\GraphQl\Schema\Type\ResolveInfo;

/**
 * Class NewsletterSignup
 * @package Pinpoint\ReactNewsletter\Model\Resolver
 */
class NewsletterSignup implements ResolverInterface
{
    /**
     * @var \Magento\Newsletter\Model\SubscriberFactory
     */
    protected $subscriberFactory;

    /**
     * NewsletterSignup constructor.
     * @param \Magento\Newsletter\Model\SubscriberFactory $subscriberFactory
     */
    public function __construct(
        \Magento\Newsletter\Model\SubscriberFactory $subscriberFactory
    ) {
        $this->subscriberFactory = $subscriberFactory;
    }

    /**
     * @inheritdoc
     */
    public function resolve(
        Field $field,
        $context,
        ResolveInfo $info,
        array $value = null,
        array $args = null
    ) {
        if (isset($args['email'])) {
            $subscriber = $this->subscriberFactory->create()->loadByEmail($args['email']);

            if (!$subscriber->getId()) {
                $this->subscriberFactory->create()->subscribe($args['email']);
                return true;
            }
        }

        return false;
    }
}
