const HtmlWebPackPlugin = require("html-webpack-plugin");

module.exports = {
    module: {
        rules: [
            {
                test: /\.(js|jsx)$/,
                exclude: /node_modules/,
                use: {
                    loader: "babel-loader"
                }
            },
            {
                test: /\.html$/,
                use: [
                    {
                        loader: "html-loader"
                    }
                ]
            }
        ]
    },
    output: {
        path: __dirname + '/web',
        publicPath: '<?= $block->getViewFileUrl("Pinpoint_ReactNewsletter") ?>',
        filename: 'js/compiled/main.js'
    },
    plugins: [
        new HtmlWebPackPlugin({
            template: "./src/index.html",
            filename: "../templates/newsletter-signup.phtml"
        })
    ]
};